Name:           pmd
Epoch:          0
Version:        5.3.2
Release:        1%{?dist}
Summary:        Scans Java source code and looks for potential problems
License:        BSD
URL:            http://pmd.sourceforge.net/
BuildArch:      noarch

Source0:        http://downloads.sourceforge.net/project/pmd/pmd/%{version}/pmd-src-%{version}.zip

# fix api incompatibilities with newer saxon
# not sent upstream
Patch1:         saxon.patch

BuildRequires:  maven-local
BuildRequires:  mvn(com.beust:jcommander)
BuildRequires:  mvn(commons-io:commons-io)
BuildRequires:  mvn(jaxen:jaxen)
BuildRequires:  mvn(junit:junit)
BuildRequires:  mvn(net.java.dev.javacc:javacc)
BuildRequires:  mvn(net.sf.saxon:saxon)
BuildRequires:  mvn(net.sourceforge.pmd:pmd-build)
BuildRequires:  mvn(org.apache.ant:ant)
BuildRequires:  mvn(org.apache.ant:ant-testutil)
BuildRequires:  mvn(org.apache.commons:commons-lang3)
BuildRequires:  mvn(org.apache.maven.doxia:doxia-module-markdown)
BuildRequires:  mvn(org.apache.maven.plugins:maven-antrun-plugin)
BuildRequires:  mvn(org.apache.maven.plugins:maven-assembly-plugin)
BuildRequires:  mvn(org.apache.maven.plugins:maven-site-plugin)
BuildRequires:  mvn(org.codehaus.mojo:build-helper-maven-plugin)
BuildRequires:  mvn(org.mozilla:rhino)
BuildRequires:  mvn(org.ow2.asm:asm)
BuildRequires:  mvn(org.sonatype.oss:oss-parent:pom:)

%description
PMD scans Java source code and looks for potential problems like:
* Possible bugs: empty try/catch/finally/switch statements
+ Dead code: unused local variables, parameters and private methods
+ Suboptimal code: wasteful String/StringBuffer usage
+ Overcomplicated expressions: unnecessary if statements, for loops
  that could be while loops
+ Duplicate code: copied/pasted code means copied/pasted bugs

PMD has plugins for JDeveloper, Eclipse, JEdit, JBuilder, BlueJ,
CodeGuide, NetBeans/Sun Java Studio Enterprise/Creator, IntelliJ IDEA,
TextPad, Maven, Ant, Gel, JCreator, and Emacs.

%package javadoc
Summary:        API documentation for %{name}

%description javadoc
API documentation for %{name}.

%prep
%setup -q -n %{name}-src-%{version}
%patch1 -p1

# remove all binary libs
find . -name "*.jar" -exec rm -f {} \;
find . -name "*.class" -exec rm -f {} \;

%mvn_alias : pmd:pmd

%pom_xpath_remove pom:build/pom:extensions

sed -i 's/net.sourceforge.saxon/net.sf.saxon/' `find -name pom.xml`

%pom_xpath_set -r '//pom:property[@name="javacc.jar"]/@value' `xmvn-resolve net.java.dev.javacc:javacc`

%build
# tests require com.github.tomakehurst:wiremock
%mvn_build -f -- -P!jdk9-disabled

%install
%mvn_install

%files -f .mfiles
%license LICENSE

%files javadoc -f .mfiles-javadoc
%license LICENSE

%changelog
* Mon May 25 2015 Mikolaj Izdebski <mizdebsk@redhat.com> - 0:5.3.2-1
- Update to upstream version 5.3.2

* Thu May 14 2015 Mikolaj Izdebski <mizdebsk@redhat.com> - 0:5.3.1-1
- Update to upstream version 5.3.1

* Tue Apr 14 2015 Mikolaj Izdebski <mizdebsk@redhat.com> - 0:5.2.3-2
- Cleanup spec file

* Mon Jan 19 2015 Michael Simacek <msimacek@redhat.com> - 0:5.2.3-1
- Update to upstream version 5.2.3

* Tue Sep 2 2014 Alexander Kurtakov <akurtako@redhat.com> 0:5.1.3-1
- Update to upstream 5.1.3.

* Tue Jul 29 2014 Alexander Kurtakov <akurtako@redhat.com> 0:5.1.2-1
- Update to upstream 5.1.2.

* Sat Jun 07 2014 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0:5.1.1-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_21_Mass_Rebuild

* Mon May 12 2014 Alexander Kurtakov <akurtako@redhat.com> 0:5.1.1-1
- Update to upstream 5.1.1.

* Tue Mar 11 2014 Michael Simacek <msimacek@redhat.com> - 0:5.1.0-2
- Drop manual requires
- Remove wagon-ssh from extensions

* Sat Feb 22 2014 Alexander Kurtakov <akurtako@redhat.com> 0:5.1.0-1
- Update to upstream 5.1.0.

* Tue Oct 15 2013 Mikolaj Izdebski <mizdebsk@redhat.com> - 0:5.0.5-2
- Require saxon >= 9.3.0.4-9

* Tue Aug 13 2013 Alexander Kurtakov <akurtako@redhat.com> 0:5.0.5-1
- Update to latest upstream.

* Sun Aug 04 2013 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0:5.0.4-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_20_Mass_Rebuild

* Mon Jul 01 2013 Mat Booth <fedora@matbooth.co.uk> - 0:5.0.4-2
- Add missing requires on ant and javacc

* Sun Jun 30 2013 Mat Booth <fedora@matbooth.co.uk> - 0:5.0.4-1
- Update to latest upstream version

* Thu Feb 14 2013 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0:4.2.5-15
- Rebuilt for https://fedoraproject.org/wiki/Fedora_19_Mass_Rebuild

* Sat Jul 21 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0:4.2.5-14
- Rebuilt for https://fedoraproject.org/wiki/Fedora_18_Mass_Rebuild

* Tue May 22 2012 Stanislav Ochotnicky <sochotnicky@redhat.com> - 0:4.2.5-13
- Use unversioned jars to prevent further build breakages
- Update to current guidelines

* Sat Jan 14 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0:4.2.5-12
- Rebuilt for https://fedoraproject.org/wiki/Fedora_17_Mass_Rebuild

* Tue Jun 28 2011 Alexander Kurtakov <akurtako@redhat.com> 0:4.2.5-11
- Fix FTBFS.
- Current guidelines updates.

* Thu Feb 24 2011 Alexander Kurtakov <akurtako@redhat.com> 0:4.2.5-10
- Let it conform to new packaging guidelines.

* Wed Feb 09 2011 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0:4.2.5-9
- Rebuilt for https://fedoraproject.org/wiki/Fedora_15_Mass_Rebuild

* Mon Nov 29 2010 Jerry James <loganjerry@gmail.com> - 0:4.2.5-8
- Fix maven ant dep (bz 643748).
- Add LICENSE.txt to -javadoc package.
- Remove BuildRoot tag.

* Tue Sep  7 2010 Jerry James <loganjerry@gmail.com> - 0:4.2.5-7
- Update junit4 dependency for junit 4.8.2.

* Wed Jun  2 2010 Jerry James <loganjerry@gmail.com> - 0:4.2.5-6
- Update objectweb-asm dependency for version 3.2.

* Fri Nov 20 2009 Jerry James <loganjerry@gmail.com> - 0:4.2.5-5
- Update junit4 dependency for junit 4.6.

* Wed Aug 19 2009 Andrew Overholt <overholt@redhat.com> 0:4.2.5-4
- Install POM file and depmap entry

* Sun Jul 26 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0:4.2.5-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_12_Mass_Rebuild

* Thu Feb 26 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0:4.2.5-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_11_Mass_Rebuild

* Wed Feb 11 2009 Jerry James <loganjerry@gmail.com> - 0:4.2.5-1
- Upgrade to 4.2.5

* Wed Jan 14 2009 Jerry James <loganjerry@gmail.com> - 0:4.2.4-1
- Upgrade to 4.2.4
- Drop unnecessary scripts/files in etc
- Add more documentation files
- Drop useless manual subpackage; it's really small, and contains files that
  should be docs for the main package

* Wed Jul  9 2008 Tom "spot" Callaway <tcallawa@redhat.com> - 0:3.6-1.4
- fix license tag
- drop disttag

* Mon Mar 26 2007 Matt Wringe <mwringe@redhat.com> - 0:3.6-1jpp.3
- Fix unowned doc directory for pmd

* Mon Mar 19 2007 Matt Wringe <mwringe@redhat.com> - 0:3.6-1jpp.2
- Add missing jakarta-commons-oro build requires

* Tue Mar 13 2007 Jeff Johnston <jjohnstn@redhat.com> - 0:3.6-1jpp.1
- Updated per Fedora package review process
- Resolves: #227109

* Mon Jun 19 2006 Deepak Bhole <dbhole@redhat.com> - 0:3.6-1jpp
- Upgrade to 3.6

* Fri Mar 10 2006 Fernando Nasser <fnasser@redhat.com> - 0:3.3-2jpp
- First JPP 1.7 build

* Wed Nov 09 2005 Ralph Apel <r.apel at r-apel.de> - 0:3.3-1jpp
- Upgrade to 3.3
- Fix Groups

* Tue Feb 22 2005 Laurent Goujon <laurent at gobio2.net> - 2.3-1jpp
- Upgrade to 2.3
- Use bin/build.xml

* Mon Sep 13 2004 Ralph Apel <r.apel at r-apel.de> - 1.9-2jpp
- Drop saxpath requirements
- Require jaxen >= 0:1.1
- Relax some versioned requirements

* Wed Aug 25 2004 Fernando Nasser <fnasser@redhat.com> - 1.9-1jpp
- Upgrade to 1.9

* Tue Aug 24 2004 Fernando Nasser <fnasser@redhat.com> - 0:1.5-4jpp
- Rebuild with Ant 1.6.2

* Fri Aug 06 2004 Ralph Apel <r.apel at r-apel.de> - 1.5-3jpp
- Void change

* Tue Jun 01 2004 Randy Watler <rwatler at finali.com> - 1.5-2jpp
- Upgrade to Ant 1.6.X

* Wed Mar 24 2004 Ralph Apel <r.apel at r-apel.de> 1.5-1jpp
- first JPackage release
